/*!
@fileoverview gl-matrix - High performance matrix and vector operations
@author Brandon Jones
@author Colin MacKenzie IV
@version 3.0.0-0

Copyright (c) 2015-2018, Brandon Jones, Colin MacKenzie IV.

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

*/
!function(t,a){"object"==typeof exports&&"undefined"!=typeof module?a(exports):"function"==typeof define&&define.amd?define(["exports"],a):a(t.glMatrix={})}(this,function(t){"use strict";var a=1e-6,n="undefined"!=typeof Float32Array?Float32Array:Array,r=Math.random;var u=Math.PI/180;var e=Object.freeze({EPSILON:a,get ARRAY_TYPE(){return n},RANDOM:r,setMatrixArrayType:function(t){n=t},toRadian:function(t){return t*u},equals:function(t,n){return Math.abs(t-n)<=a*Math.max(1,Math.abs(t),Math.abs(n))}});function o(t,a,n){var r=a[0],u=a[1],e=a[2],o=a[3],i=n[0],h=n[1],M=n[2],c=n[3];return t[0]=r*i+e*h,t[1]=u*i+o*h,t[2]=r*M+e*c,t[3]=u*M+o*c,t}function i(t,a,n){return t[0]=a[0]-n[0],t[1]=a[1]-n[1],t[2]=a[2]-n[2],t[3]=a[3]-n[3],t}var h=o,M=i,c=Object.freeze({create:function(){var t=new n(4);return n!=Float32Array&&(t[1]=0,t[2]=0),t[0]=1,t[3]=1,t},clone:function(t){var a=new n(4);return a[0]=t[0],a[1]=t[1],a[2]=t[2],a[3]=t[3],a},copy:function(t,a){return t[0]=a[0],t[1]=a[1],t[2]=a[2],t[3]=a[3],t},identity:function(t){return t[0]=1,t[1]=0,t[2]=0,t[3]=1,t},fromValues:function(t,a,r,u){var e=new n(4);return e[0]=t,e[1]=a,e[2]=r,e[3]=u,e},set:function(t,a,n,r,u){return t[0]=a,t[1]=n,t[2]=r,t[3]=u,t},transpose:function(t,a){if(t===a){var n=a[1];t[1]=a[2],t[2]=n}else t[0]=a[0],t[1]=a[2],t[2]=a[1],t[3]=a[3];return t},invert:function(t,a){var n=a[0],r=a[1],u=a[2],e=a[3],o=n*e-u*r;return o?(o=1/o,t[0]=e*o,t[1]=-r*o,t[2]=-u*o,t[3]=n*o,t):null},adjoint:function(t,a){var n=a[0];return t[0]=a[3],t[1]=-a[1],t[2]=-a[2],t[3]=n,t},determinant:function(t){return t[0]*t[3]-t[2]*t[1]},multiply:o,rotate:function(t,a,n){var r=a[0],u=a[1],e=a[2],o=a[3],i=Math.sin(n),h=Math.cos(n);return t[0]=r*h+e*i,t[1]=u*h+o*i,t[2]=r*-i+e*h,t[3]=u*-i+o*h,t},scale:function(t,a,n){var r=a[0],u=a[1],e=a[2],o=a[3],i=n[0],h=n[1];return t[0]=r*i,t[1]=u*i,t[2]=e*h,t[3]=o*h,t},fromRotation:function(t,a){var n=Math.sin(a),r=Math.cos(a);return t[0]=r,t[1]=n,t[2]=-n,t[3]=r,t},fromScaling:function(t,a){return t[0]=a[0],t[1]=0,t[2]=0,t[3]=a[1],t},str:function(t){return"mat2("+t[0]+", "+t[1]+", "+t[2]+", "+t[3]+")"},frob:function(t){return Math.sqrt(Math.pow(t[0],2)+Math.pow(t[1],2)+Math.pow(t[2],2)+Math.pow(t[3],2))},LDU:function(t,a,n,r){return t[2]=r[2]/r[0],n[0]=r[0],n[1]=r[1],n[3]=r[3]-t[2]*n[1],[t,a,n]},add:function(t,a,n){return t[0]=a[0]+n[0],t[1]=a[1]+n[1],t[2]=a[2]+n[2],t[3]=a[3]+n[3],t},subtract:i,exactEquals:function(t,a){return t[0]===a[0]&&t[1]===a[1]&&t[2]===a[2]&&t[3]===a[3]},equals:function(t,n){var r=t[0],u=t[1],e=t[2],o=t[3],i=n[0],h=n[1],M=n[2],c=n[3];return Math.abs(r-i)<=a*Math.max(1,Math.abs(r),Math.abs(i))&&Math.abs(u-h)<=a*Math.max(1,Math.abs(u),Math.abs(h))&&Math.abs(e-M)<=a*Math.max(1,Math.abs(e),Math.abs(M))&&Math.abs(o-c)<=a*Math.max(1,Math.abs(o),Math.abs(c))},multiplyScalar:function(t,a,n){return t[0]=a[0]*n,t[1]=a[1]*n,t[2]=a[2]*n,t[3]=a[3]*n,t},multiplyScalarAndAdd:function(t,a,n,r){return t[0]=a[0]+n[0]*r,t[1]=a[1]+n[1]*r,t[2]=a[2]+n[2]*r,t[3]=a[3]+n[3]*r,t},mul:h,sub:M});function s(t,a,n){var r=a[0],u=a[1],e=a[2],o=a[3],i=a[4],h=a[5],M=n[0],c=n[1],s=n[2],f=n[3],l=n[4],v=n[5];return t[0]=r*M+e*c,t[1]=u*M+o*c,t[2]=r*s+e*f,t[3]=u*s+o*f,t[4]=r*l+e*v+i,t[5]=u*l+o*v+h,t}function f(t,a,n){return t[0]=a[0]-n[0],t[1]=a[1]-n[1],t[2]=a[2]-n[2],t[3]=a[3]-n[3],t[4]=a[4]-n[4],t[5]=a[5]-n[5],t}var l=s,v=f,b=Object.freeze({create:function(){var t=new n(6);return n!=Float32Array&&(t[1]=0,t[2]=0,t[4]=0,t[5]=0),t[0]=1,t[3]=1,t},clone:function(t){var a=new n(6);return a[0]=t[0],a[1]=t[1],a[2]=t[2],a[3]=t[3],a[4]=t[4],a[5]=t[5],a},copy:function(t,a){return t[0]=a[0],t[1]=a[1],t[2]=a[2],t[3]=a[3],t[4]=a[4],t[5]=a[5],t},identity:function(t){return t[0]=1,t[1]=0,t[2]=0,t[3]=1,t[4]=0,t[5]=0,t},fromValues:function(t,a,r,u,e,o){var i=new n(6);return i[0]=t,i[1]=a,i[2]=r,i[3]=u,i[4]=e,i[5]=o,i},set:function(t,a,n,r,u,e,o){return t[0]=a,t[1]=n,t[2]=r,t[3]=u,t[4]=e,t[5]=o,t},invert:function(t,a){var n=a[0],r=a[1],u=a[2],e=a[3],o=a[4],i=a[5],h=n*e-r*u;return h?(h=1/h,t[0]=e*h,t[1]=-r*h,t[2]=-u*h,t[3]=n*h,t[4]=(u*i-e*o)*h,t[5]=(r*o-n*i)*h,t):null},determinant:function(t){return t[0]*t[3]-t[1]*t[2]},multiply:s,rotate:function(t,a,n){var r=a[0],u=a[1],e=a[2],o=a[3],i=a[4],h=a[5],M=Math.sin(n),c=Math.cos(n);return t[0]=r*c+e*M,t[1]=u*c+o*M,t[2]=r*-M+e*c,t[3]=u*-M+o*c,t[4]=i,t[5]=h,t},scale:function(t,a,n){var r=a[0],u=a[1],e=a[2],o=a[3],i=a[4],h=a[5],M=n[0],c=n[1];return t[0]=r*M,t[1]=u*M,t[2]=e*c,t[3]=o*c,t[4]=i,t[5]=h,t},translate:function(t,a,n){var r=a[0],u=a[1],e=a[2],o=a[3],i=a[4],h=a[5],M=n[0],c=n[1];return t[0]=r,t[1]=u,t[2]=e,t[3]=o,t[4]=r*M+e*c+i,t[5]=u*M+o*c+h,t},fromRotation:function(t,a){var n=Math.sin(a),r=Math.cos(a);return t[0]=r,t[1]=n,t[2]=-n,t[3]=r,t[4]=0,t[5]=0,t},fromScaling:function(t,a){return t[0]=a[0],t[1]=0,t[2]=0,t[3]=a[1],t[4]=0,t[5]=0,t},fromTranslation:function(t,a){return t[0]=1,t[1]=0,t[2]=0,t[3]=1,t[4]=a[0],t[5]=a[1],t},str:function(t){return"mat2d("+t[0]+", "+t[1]+", "+t[2]+", "+t[3]+", "+t[4]+", "+t[5]+")"},frob:function(t){return Math.sqrt(Math.pow(t[0],2)+Math.pow(t[1],2)+Math.pow(t[2],2)+Math.pow(t[3],2)+Math.pow(t[4],2)+Math.pow(t[5],2)+1)},add:function(t,a,n){return t[0]=a[0]+n[0],t[1]=a[1]+n[1],t[2]=a[2]+n[2],t[3]=a[3]+n[3],t[4]=a[4]+n[4],t[5]=a[5]+n[5],t},subtract:f,multiplyScalar:function(t,a,n){return t[0]=a[0]*n,t[1]=a[1]*n,t[2]=a[2]*n,t[3]=a[3]*n,t[4]=a[4]*n,t[5]=a[5]*n,t},multiplyScalarAndAdd:function(t,a,n,r){return t[0]=a[0]+n[0]*r,t[1]=a[1]+n[1]*r,t[2]=a[2]+n[2]*r,t[3]=a[3]+n[3]*r,t[4]=a[4]+n[4]*r,t[5]=a[5]+n[5]*r,t},exactEquals:function(t,a){return t[0]===a[0]&&t[1]===a[1]&&t[2]===a[2]&&t[3]===a[3]&&t[4]===a[4]&&t[5]===a[5]},equals:function(t,n){var r=t[0],u=t[1],e=t[2],o=t[3],i=t[4],h=t[5],M=n[0],c=n[1],s=n[2],f=n[3],l=n[4],v=n[5];return Math.abs(r-M)<=a*Math.max(1,Math.abs(r),Math.abs(M))&&Math.abs(u-c)<=a*Math.max(1,Math.abs(u),Math.abs(c))&&Math.abs(e-s)<=a*Math.max(1,Math.abs(e),Math.abs(s))&&Math.abs(o-f)<=a*Math.max(1,Math.abs(o),Math.abs(f))&&Math.abs(i-l)<=a*Math.max(1,Math.abs(i),Math.abs(l))&&Math.abs(h-v)<=a*Math.max(1,Math.abs(h),Math.abs(v))},mul:l,sub:v});function m(){var t=new n(9);return n!=Float32Array&&(t[1]=0,t[2]=0,t[3]=0,t[5]=0,t[6]=0,t[7]=0),t[0]=1,t[4]=1,t[8]=1,t}function d(t,a,n){var r=a[0],u=a[1],e=a[2],o=a[3],i=a[4],h=a[5],M=a[6],c=a[7],s=a[8],f=n[0],l=n[1],v=n[2],b=n[3],m=n[4],d=n[5],p=n[6],x=n[7],q=n[8];return t[0]=f*r+l*o+v*M,t[1]=f*u+l*i+v*c,t[2]=f*e+l*h+v*s,t[3]=b*r+m*o+d*M,t[4]=b*u+m*i+d*c,t[5]=b*e+m*h+d*s,t[6]=p*r+x*o+q*M,t[7]=p*u+x*i+q*c,t[8]=p*e+x*h+q*s,t}function p(t,a,n){return t[0]=a[0]-n[0],t[1]=a[1]-n[1],t[2]=a[2]-n[2],t[3]=a[3]-n[3],t[4]=a[4]-n[4],t[5]=a[5]-n[5],t[6]=a[6]-n[6],t[7]=a[7]-n[7],t[8]=a[8]-n[8],t}var x=d,q=p,w=Object.freeze({create:m,fromMat4:function(t,a){return t[0]=a[0],t[1]=a[1],t[2]=a[2],t[3]=a[4],t[4]=a[5],t[5]=a[6],t[6]=a[8],t[7]=a[9],t[8]=a[10],t},clone:function(t){var a=new n(9);return a[0]=t[0],a[1]=t[1],a[2]=t[2],a[3]=t[3],a[4]=t[4],a[5]=t[5],a[6]=t[6],a[7]=t[7],a[8]=t[8],a},copy:function(t,a){return t[0]=a[0],t[1]=a[1],t[2]=a[2],t[3]=a[3],t[4]=a[4],t[5]=a[5],t[6]=a[6],t[7]=a[7],t[8]=a[8],t},fromValues:function(t,a,r,u,e,o,i,h,M){var c=new n(9);return c[0]=t,c[1]=a,c[2]=r,c[3]=u,c[4]=e,c[5]=o,c[6]=i,c[7]=h,c[8]=M,c},set:function(t,a,n,r,u,e,o,i,h,M){return t[0]=a,t[1]=n,t[2]=r,t[3]=u,t[4]=e,t[5]=o,t[6]=i,t[7]=h,t[8]=M,t},identity:function(t){return t[0]=1,t[1]=0,t[2]=0,t[3]=0,t[4]=1,t[5]=0,t[6]=0,t[7]=0,t[8]=1,t},transpose:function(t,a){if(t===a){var n=a[1],r=a[2],u=a[5];t[1]=a[3],t[2]=a[6],t[3]=n,t[5]=a[7],t[6]=r,t[7]=u}else t[0]=a[0],t[1]=a[3],t[2]=a[6],t[3]=a[1],t[4]=a[4],t[5]=a[7],t[6]=a[2],t[7]=a[5],t[8]=a[8];return t},invert:function(t,a){var n=a[0],r=a[1],u=a[2],e=a[3],o=a[4],i=a[5],h=a[6],M=a[7],c=a[8],s=c*o-i*M,f=-c*e+i*h,l=M*e-o*h,v=n*s+r*f+u*l;return v?(v=1/v,t[0]=s*v,t[1]=(-c*r+u*M)*v,t[2]=(i*r-u*o)*v,t[3]=f*v,t[4]=(c*n-u*h)*v,t[5]=(-i*n+u*e)*v,t[6]=l*v,t[7]=(-M*n+r*h)*v,t[8]=(o*n-r*e)*v,t):null},adjoint:function(t,a){var n=a[0],r=a[1],u=a[2],e=a[3],o=a[4],i=a[5],h=a[6],M=a[7],c=a[8];return t[0]=o*c-i*M,t[1]=u*M-r*c,t[2]=r*i-u*o,t[3]=i*h-e*c,t[4]=n*c-u*h,t[5]=u*e-n*i,t[6]=e*M-o*h,t[7]=r*h-n*M,t[8]=n*o-r*e,t},determinant:function(t){var a=t[0],n=t[1],r=t[2],u=t[3],e=t[4],o=t[5],i=t[6],h=t[7],M=t[8];return a*(M*e-o*h)+n*(-M*u+o*i)+r*(h*u-e*i)},multiply:d,translate:function(t,a,n){var r=a[0],u=a[1],e=a[2],o=a[3],i=a[4],h=a[5],M=a[6],c=a[7],s=a[8],f=n[0],l=n[1];return t[0]=r,t[1]=u,t[2]=e,t[3]=o,t[4]=i,t[5]=h,t[6]=f*r+l*o+M,t[7]=f*u+l*i+c,t[8]=f*e+l*h+s,t},rotate:function(t,a,n){var r=a[0],u=a[1],e=a[2],o=a[3],i=a[4],h=a[5],M=a[6],c=a[7],s=a[8],f=Math.sin(n),l=Math.cos(n);return t[0]=l*r+f*o,t[1]=l*u+f*i,t[2]=l*e+f*h,t[3]=l*o-f*r,t[4]=l*i-f*u,t[5]=l*h-f*e,t[6]=M,t[7]=c,t[8]=s,t},scale:function(t,a,n){var r=n[0],u=n[1];return t[0]=r*a[0],t[1]=r*a[1],t[2]=r*a[2],t[3]=u*a[3],t[4]=u*a[4],t[5]=u*a[5],t[6]=a[6],t[7]=a[7],t[8]=a[8],t},fromTranslation:function(t,a){return t[0]=1,t[1]=0,t[2]=0,t[3]=0,t[4]=1,t[5]=0,t[6]=a[0],t[7]=a[1],t[8]=1,t},fromRotation:function(t,a){var n=Math.sin(a),r=Math.cos(a);return t[0]=r,t[1]=n,t[2]=0,t[3]=-n,t[4]=r,t[5]=0,t[6]=0,t[7]=0,t[8]=1,t},fromScaling:function(t,a){return t[0]=a[0],t[1]=0,t[2]=0,t[3]=0,t[4]=a[1],t[5]=0,t[6]=0,t[7]=0,t[8]=1,t},fromMat2d:function(t,a){return t[0]=a[0],t[1]=a[1],t[2]=0,t[3]=a[2],t[4]=a[3],t[5]=0,t[6]=a[4],t[7]=a[5],t[8]=1,t},fromQuat:function(t,a){var n=a[0],r=a[1],u=a[2],e=a[3],o=n+n,i=r+r,h=u+u,M=n*o,c=r*o,s=r*i,f=u*o,l=u*i,v=u*h,b=e*o,m=e*i,d=e*h;return t[0]=1-s-v,t[3]=c-d,t[6]=f+m,t[1]=c+d,t[4]=1-M-v,t[7]=l-b,t[2]=f-m,t[5]=l+b,t[8]=1-M-s,t},normalFromMat4:function(t,a){var n=a[0],r=a[1],u=a[2],e=a[3],o=a[4],i=a[5],h=a[6],M=a[7],c=a[8],s=a[9],f=a[10],l=a[11],v=a[12],b=a[13],m=a[14],d=a[15],p=n*i-r*o,x=n*h-u*o,q=n*M-e*o,w=r*h-u*i,y=r*M-e*i,g=u*M-e*h,A=c*b-s*v,R=c*m-f*v,P=c*d-l*v,j=s*m-f*b,z=s*d-l*b,I=f*d-l*m,S=p*I-x*z+q*j+w*P-y*R+g*A;return S?(S=1/S,t[0]=(i*I-h*z+M*j)*S,t[1]=(h*P-o*I-M*R)*S,t[2]=(o*z-i*P+M*A)*S,t[3]=(u*z-r*I-e*j)*S,t[4]=(n*I-u*P+e*R)*S,t[5]=(r*P-n*z-e*A)*S,t[6]=(b*g-m*y+d*w)*S,t[7]=(m*q-v*g-d*x)*S,t[8]=(v*y-b*q+d*p)*S,t):null},projection:function(t,a,n){return t[0]=2/a,t[1]=0,t[2]=0,t[3]=0,t[4]=-2/n,t[5]=0,t[6]=-1,t[7]=1,t[8]=1,t},str:function(t){return"mat3("+t[0]+", "+t[1]+", "+t[2]+", "+t[3]+", "+t[4]+", "+t[5]+", "+t[6]+", "+t[7]+", "+t[8]+")"},frob:function(t){return Math.sqrt(Math.pow(t[0],2)+Math.pow(t[1],2)+Math.pow(t[2],2)+Math.pow(t[3],2)+Math.pow(t[4],2)+Math.pow(t[5],2)+Math.pow(t[6],2)+Math.pow(t[7],2)+Math.pow(t[8],2))},add:function(t,a,n){return t[0]=a[0]+n[0],t[1]=a[1]+n[1],t[2]=a[2]+n[2],t[3]=a[3]+n[3],t[4]=a[4]+n[4],t[5]=a[5]+n[5],t[6]=a[6]+n[6],t[7]=a[7]+n[7],t[8]=a[8]+n[8],t},subtract:p,multiplyScalar:function(t,a,n){return t[0]=a[0]*n,t[1]=a[1]*n,t[2]=a[2]*n,t[3]=a[3]*n,t[4]=a[4]*n,t[5]=a[5]*n,t[6]=a[6]*n,t[7]=a[7]*n,t[8]=a[8]*n,t},multiplyScalarAndAdd:function(t,a,n,r){return t[0]=a[0]+n[0]*r,t[1]=a[1]+n[1]*r,t[2]=a[2]+n[2]*r,t[3]=a[3]+n[3]*r,t[4]=a[4]+n[4]*r,t[5]=a[5]+n[5]*r,t[6]=a[6]+n[6]*r,t[7]=a[7]+n[7]*r,t[8]=a[8]+n[8]*r,t},exactEquals:function(t,a){return t[0]===a[0]&&t[1]===a[1]&&t[2]===a[2]&&t[3]===a[3]&&t[4]===a[4]&&t[5]===a[5]&&t[6]===a[6]&&t[7]===a[7]&&t[8]===a[8]},equals:function(t,n){var r=t[0],u=t[1],e=t[2],o=t[3],i=t[4],h=t[5],M=t[6],c=t[7],s=t[8],f=n[0],l=n[1],v=n[2],b=n[3],m=n[4],d=n[5],p=n[6],x=n[7],q=n[8];return Math.abs(r-f)<=a*Math.max(1,Math.abs(r),Math.abs(f))&&Math.abs(u-l)<=a*Math.max(1,Math.abs(u),Math.abs(l))&&Math.abs(e-v)<=a*Math.max(1,Math.abs(e),Math.abs(v))&&Math.abs(o-b)<=a*Math.max(1,Math.abs(o),Math.abs(b))&&Math.abs(i-m)<=a*Math.max(1,Math.abs(i),Math.abs(m))&&Math.abs(h-d)<=a*Math.max(1,Math.abs(h),Math.abs(d))&&Math.abs(M-p)<=a*Math.max(1,Math.abs(M),Math.abs(p))&&Math.abs(c-x)<=a*Math.max(1,Math.abs(c),Math.abs(x))&&Math.abs(s-q)<=a*Math.max(1,Math.abs(s),Math.abs(q))},mul:x,sub:q});function y(t){return t[0]=1,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=1,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=1,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t}function g(t,a,n){var r=a[0],u=a[1],e=a[2],o=a[3],i=a[4],h=a[5],M=a[6],c=a[7],s=a[8],f=a[9],l=a[10],v=a[11],b=a[12],m=a[13],d=a[14],p=a[15],x=n[0],q=n[1],w=n[2],y=n[3];return t[0]=x*r+q*i+w*s+y*b,t[1]=x*u+q*h+w*f+y*m,t[2]=x*e+q*M+w*l+y*d,t[3]=x*o+q*c+w*v+y*p,x=n[4],q=n[5],w=n[6],y=n[7],t[4]=x*r+q*i+w*s+y*b,t[5]=x*u+q*h+w*f+y*m,t[6]=x*e+q*M+w*l+y*d,t[7]=x*o+q*c+w*v+y*p,x=n[8],q=n[9],w=n[10],y=n[11],t[8]=x*r+q*i+w*s+y*b,t[9]=x*u+q*h+w*f+y*m,t[10]=x*e+q*M+w*l+y*d,t[11]=x*o+q*c+w*v+y*p,x=n[12],q=n[13],w=n[14],y=n[15],t[12]=x*r+q*i+w*s+y*b,t[13]=x*u+q*h+w*f+y*m,t[14]=x*e+q*M+w*l+y*d,t[15]=x*o+q*c+w*v+y*p,t}function A(t,a,n){var r=a[0],u=a[1],e=a[2],o=a[3],i=r+r,h=u+u,M=e+e,c=r*i,s=r*h,f=r*M,l=u*h,v=u*M,b=e*M,m=o*i,d=o*h,p=o*M;return t[0]=1-(l+b),t[1]=s+p,t[2]=f-d,t[3]=0,t[4]=s-p,t[5]=1-(c+b),t[6]=v+m,t[7]=0,t[8]=f+d,t[9]=v-m,t[10]=1-(c+l),t[11]=0,t[12]=n[0],t[13]=n[1],t[14]=n[2],t[15]=1,t}function R(t,a){return t[0]=a[12],t[1]=a[13],t[2]=a[14],t}function P(t,a){var n=a[0]+a[5]+a[10],r=0;return n>0?(r=2*Math.sqrt(n+1),t[3]=.25*r,t[0]=(a[6]-a[9])/r,t[1]=(a[8]-a[2])/r,t[2]=(a[1]-a[4])/r):a[0]>a[5]&&a[0]>a[10]?(r=2*Math.sqrt(1+a[0]-a[5]-a[10]),t[3]=(a[6]-a[9])/r,t[0]=.25*r,t[1]=(a[1]+a[4])/r,t[2]=(a[8]+a[2])/r):a[5]>a[10]?(r=2*Math.sqrt(1+a[5]-a[0]-a[10]),t[3]=(a[8]-a[2])/r,t[0]=(a[1]+a[4])/r,t[1]=.25*r,t[2]=(a[6]+a[9])/r):(r=2*Math.sqrt(1+a[10]-a[0]-a[5]),t[3]=(a[1]-a[4])/r,t[0]=(a[8]+a[2])/r,t[1]=(a[6]+a[9])/r,t[2]=.25*r),t}function j(t,a,n){return t[0]=a[0]-n[0],t[1]=a[1]-n[1],t[2]=a[2]-n[2],t[3]=a[3]-n[3],t[4]=a[4]-n[4],t[5]=a[5]-n[5],t[6]=a[6]-n[6],t[7]=a[7]-n[7],t[8]=a[8]-n[8],t[9]=a[9]-n[9],t[10]=a[10]-n[10],t[11]=a[11]-n[11],t[12]=a[12]-n[12],t[13]=a[13]-n[13],t[14]=a[14]-n[14],t[15]=a[15]-n[15],t}var z=g,I=j,S=Object.freeze({create:function(){var t=new n(16);return n!=Float32Array&&(t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[11]=0,t[12]=0,t[13]=0,t[14]=0),t[0]=1,t[5]=1,t[10]=1,t[15]=1,t},clone:function(t){var a=new n(16);return a[0]=t[0],a[1]=t[1],a[2]=t[2],a[3]=t[3],a[4]=t[4],a[5]=t[5],a[6]=t[6],a[7]=t[7],a[8]=t[8],a[9]=t[9],a[10]=t[10],a[11]=t[11],a[12]=t[12],a[13]=t[13],a[14]=t[14],a[15]=t[15],a},copy:function(t,a){return t[0]=a[0],t[1]=a[1],t[2]=a[2],t[3]=a[3],t[4]=a[4],t[5]=a[5],t[6]=a[6],t[7]=a[7],t[8]=a[8],t[9]=a[9],t[10]=a[10],t[11]=a[11],t[12]=a[12],t[13]=a[13],t[14]=a[14],t[15]=a[15],t},fromValues:function(t,a,r,u,e,o,i,h,M,c,s,f,l,v,b,m){var d=new n(16);return d[0]=t,d[1]=a,d[2]=r,d[3]=u,d[4]=e,d[5]=o,d[6]=i,d[7]=h,d[8]=M,d[9]=c,d[10]=s,d[11]=f,d[12]=l,d[13]=v,d[14]=b,d[15]=m,d},set:function(t,a,n,r,u,e,o,i,h,M,c,s,f,l,v,b,m){return t[0]=a,t[1]=n,t[2]=r,t[3]=u,t[4]=e,t[5]=o,t[6]=i,t[7]=h,t[8]=M,t[9]=c,t[10]=s,t[11]=f,t[12]=l,t[13]=v,t[14]=b,t[15]=m,t},identity:y,transpose:function(t,a){if(t===a){var n=a[1],r=a[2],u=a[3],e=a[6],o=a[7],i=a[11];t[1]=a[4],t[2]=a[8],t[3]=a[12],t[4]=n,t[6]=a[9],t[7]=a[13],t[8]=r,t[9]=e,t[11]=a[14],t[12]=u,t[13]=o,t[14]=i}else t[0]=a[0],t[1]=a[4],t[2]=a[8],t[3]=a[12],t[4]=a[1],t[5]=a[5],t[6]=a[9],t[7]=a[13],t[8]=a[2],t[9]=a[6],t[10]=a[10],t[11]=a[14],t[12]=a[3],t[13]=a[7],t[14]=a[11],t[15]=a[15];return t},invert:function(t,a){var n=a[0],r=a[1],u=a[2],e=a[3],o=a[4],i=a[5],h=a[6],M=a[7],c=a[8],s=a[9],f=a[10],l=a[11],v=a[12],b=a[13],m=a[14],d=a[15],p=n*i-r*o,x=n*h-u*o,q=n*M-e*o,w=r*h-u*i,y=r*M-e*i,g=u*M-e*h,A=c*b-s*v,R=c*m-f*v,P=c*d-l*v,j=s*m-f*b,z=s*d-l*b,I=f*d-l*m,S=p*I-x*z+q*j+w*P-y*R+g*A;return S?(S=1/S,t[0]=(i*I-h*z+M*j)*S,t[1]=(u*z-r*I-e*j)*S,t[2]=(b*g-m*y+d*w)*S,t[3]=(f*y-s*g-l*w)*S,t[4]=(h*P-o*I-M*R)*S,t[5]=(n*I-u*P+e*R)*S,t[6]=(m*q-v*g-d*x)*S,t[7]=(c*g-f*q+l*x)*S,t[8]=(o*z-i*P+M*A)*S,t[9]=(r*P-n*z-e*A)*S,t[10]=(v*y-b*q+d*p)*S,t[11]=(s*q-c*y-l*p)*S,t[12]=(i*R-o*j-h*A)*S,t[13]=(n*j-r*R+u*A)*S,t[14]=(b*x-v*w-m*p)*S,t[15]=(c*w-s*x+f*p)*S,t):null},adjoint:function(t,a){var n=a[0],r=a[1],u=a[2],e=a[3],o=a[4],i=a[5],h=a[6],M=a[7],c=a[8],s=a[9],f=a[10],l=a[11],v=a[12],b=a[13],m=a[14],d=a[15];return t[0]=i*(f*d-l*m)-s*(h*d-M*m)+b*(h*l-M*f),t[1]=-(r*(f*d-l*m)-s*(u*d-e*m)+b*(u*l-e*f)),t[2]=r*(h*d-M*m)-i*(u*d-e*m)+b*(u*M-e*h),t[3]=-(r*(h*l-M*f)-i*(u*l-e*f)+s*(u*M-e*h)),t[4]=-(o*(f*d-l*m)-c*(h*d-M*m)+v*(h*l-M*f)),t[5]=n*(f*d-l*m)-c*(u*d-e*m)+v*(u*l-e*f),t[6]=-(n*(h*d-M*m)-o*(u*d-e*m)+v*(u*M-e*h)),t[7]=n*(h*l-M*f)-o*(u*l-e*f)+c*(u*M-e*h),t[8]=o*(s*d-l*b)-c*(i*d-M*b)+v*(i*l-M*s),t[9]=-(n*(s*d-l*b)-c*(r*d-e*b)+v*(r*l-e*s)),t[10]=n*(i*d-M*b)-o*(r*d-e*b)+v*(r*M-e*i),t[11]=-(n*(i*l-M*s)-o*(r*l-e*s)+c*(r*M-e*i)),t[12]=-(o*(s*m-f*b)-c*(i*m-h*b)+v*(i*f-h*s)),t[13]=n*(s*m-f*b)-c*(r*m-u*b)+v*(r*f-u*s),t[14]=-(n*(i*m-h*b)-o*(r*m-u*b)+v*(r*h-u*i)),t[15]=n*(i*f-h*s)-o*(r*f-u*s)+c*(r*h-u*i),t},determinant:function(t){var a=t[0],n=t[1],r=t[2],u=t[3],e=t[4],o=t[5],i=t[6],h=t[7],M=t[8],c=t[9],s=t[10],f=t[11],l=t[12],v=t[13],b=t[14],m=t[15];return(a*o-n*e)*(s*m-f*b)-(a*i-r*e)*(c*m-f*v)+(a*h-u*e)*(c*b-s*v)+(n*i-r*o)*(M*m-f*l)-(n*h-u*o)*(M*b-s*l)+(r*h-u*i)*(M*v-c*l)},multiply:g,translate:function(t,a,n){var r,u,e,o,i,h,M,c,s,f,l,v,b=n[0],m=n[1],d=n[2];return a===t?(t[12]=a[0]*b+a[4]*m+a[8]*d+a[12],t[13]=a[1]*b+a[5]*m+a[9]*d+a[13],t[14]=a[2]*b+a[6]*m+a[10]*d+a[14],t[15]=a[3]*b+a[7]*m+a[11]*d+a[15]):(r=a[0],u=a[1],e=a[2],o=a[3],i=a[4],h=a[5],M=a[6],c=a[7],s=a[8],f=a[9],l=a[10],v=a[11],t[0]=r,t[1]=u,t[2]=e,t[3]=o,t[4]=i,t[5]=h,t[6]=M,t[7]=c,t[8]=s,t[9]=f,t[10]=l,t[11]=v,t[12]=r*b+i*m+s*d+a[12],t[13]=u*b+h*m+f*d+a[13],t[14]=e*b+M*m+l*d+a[14],t[15]=o*b+c*m+v*d+a[15]),t},scale:function(t,a,n){var r=n[0],u=n[1],e=n[2];return t[0]=a[0]*r,t[1]=a[1]*r,t[2]=a[2]*r,t[3]=a[3]*r,t[4]=a[4]*u,t[5]=a[5]*u,t[6]=a[6]*u,t[7]=a[7]*u,t[8]=a[8]*e,t[9]=a[9]*e,t[10]=a[10]*e,t[11]=a[11]*e,t[12]=a[12],t[13]=a[13],t[14]=a[14],t[15]=a[15],t},rotate:function(t,n,r,u){var e,o,i,h,M,c,s,f,l,v,b,m,d,p,x,q,w,y,g,A,R,P,j,z,I=u[0],S=u[1],E=u[2],O=Math.sqrt(I*I+S*S+E*E);return O<a?null:(I*=O=1/O,S*=O,E*=O,e=Math.sin(r),i=1-(o=Math.cos(r)),h=n[0],M=n[1],c=n[2],s=n[3],f=n[4],l=n[5],v=n[6],b=n[7],m=n[8],d=n[9],p=n[10],x=n[11],q=I*I*i+o,w=S*I*i+E*e,y=E*I*i-S*e,g=I*S*i-E*e,A=S*S*i+o,R=E*S*i+I*e,P=I*E*i+S*e,j=S*E*i-I*e,z=E*E*i+o,t[0]=h*q+f*w+m*y,t[1]=M*q+l*w+d*y,t[2]=c*q+v*w+p*y,t[3]=s*q+b*w+x*y,t[4]=h*g+f*A+m*R,t[5]=M*g+l*A+d*R,t[6]=c*g+v*A+p*R,t[7]=s*g+b*A+x*R,t[8]=h*P+f*j+m*z,t[9]=M*P+l*j+d*z,t[10]=c*P+v*j+p*z,t[11]=s*P+b*j+x*z,n!==t&&(t[12]=n[12],t[13]=n[13],t[14]=n[14],t[15]=n[15]),t)},rotateX:function(t,a,n){var r=Math.sin(n),u=Math.cos(n),e=a[4],o=a[5],i=a[6],h=a[7],M=a[8],c=a[9],s=a[10],f=a[11];return a!==t&&(t[0]=a[0],t[1]=a[1],t[2]=a[2],t[3]=a[3],t[12]=a[12],t[13]=a[13],t[14]=a[14],t[15]=a[15]),t[4]=e*u+M*r,t[5]=o*u+c*r,t[6]=i*u+s*r,t[7]=h*u+f*r,t[8]=M*u-e*r,t[9]=c*u-o*r,t[10]=s*u-i*r,t[11]=f*u-h*r,t},rotateY:function(t,a,n){var r=Math.sin(n),u=Math.cos(n),e=a[0],o=a[1],i=a[2],h=a[3],M=a[8],c=a[9],s=a[10],f=a[11];return a!==t&&(t[4]=a[4],t[5]=a[5],t[6]=a[6],t[7]=a[7],t[12]=a[12],t[13]=a[13],t[14]=a[14],t[15]=a[15]),t[0]=e*u-M*r,t[1]=o*u-c*r,t[2]=i*u-s*r,t[3]=h*u-f*r,t[8]=e*r+M*u,t[9]=o*r+c*u,t[10]=i*r+s*u,t[11]=h*r+f*u,t},rotateZ:function(t,a,n){var r=Math.sin(n),u=Math.cos(n),e=a[0],o=a[1],i=a[2],h=a[3],M=a[4],c=a[5],s=a[6],f=a[7];return a!==t&&(t[8]=a[8],t[9]=a[9],t[10]=a[10],t[11]=a[11],t[12]=a[12],t[13]=a[13],t[14]=a[14],t[15]=a[15]),t[0]=e*u+M*r,t[1]=o*u+c*r,t[2]=i*u+s*r,t[3]=h*u+f*r,t[4]=M*u-e*r,t[5]=c*u-o*r,t[6]=s*u-i*r,t[7]=f*u-h*r,t},fromTranslation:function(t,a){return t[0]=1,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=1,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=1,t[11]=0,t[12]=a[0],t[13]=a[1],t[14]=a[2],t[15]=1,t},fromScaling:function(t,a){return t[0]=a[0],t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=a[1],t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=a[2],t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t},fromRotation:function(t,n,r){var u,e,o,i=r[0],h=r[1],M=r[2],c=Math.sqrt(i*i+h*h+M*M);return c<a?null:(i*=c=1/c,h*=c,M*=c,u=Math.sin(n),o=1-(e=Math.cos(n)),t[0]=i*i*o+e,t[1]=h*i*o+M*u,t[2]=M*i*o-h*u,t[3]=0,t[4]=i*h*o-M*u,t[5]=h*h*o+e,t[6]=M*h*o+i*u,t[7]=0,t[8]=i*M*o+h*u,t[9]=h*M*o-i*u,t[10]=M*M*o+e,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t)},fromXRotation:function(t,a){var n=Math.sin(a),r=Math.cos(a);return t[0]=1,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=r,t[6]=n,t[7]=0,t[8]=0,t[9]=-n,t[10]=r,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t},fromYRotation:function(t,a){var n=Math.sin(a),r=Math.cos(a);return t[0]=r,t[1]=0,t[2]=-n,t[3]=0,t[4]=0,t[5]=1,t[6]=0,t[7]=0,t[8]=n,t[9]=0,t[10]=r,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t},fromZRotation:function(t,a){var n=Math.sin(a),r=Math.cos(a);return t[0]=r,t[1]=n,t[2]=0,t[3]=0,t[4]=-n,t[5]=r,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=1,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t},fromRotationTranslation:A,fromQuat2:function(t,a){var r=new n(3),u=-a[0],e=-a[1],o=-a[2],i=a[3],h=a[4],M=a[5],c=a[6],s=a[7],f=u*u+e*e+o*o+i*i;return f>0?(r[0]=2*(h*i+s*u+M*o-c*e)/f,r[1]=2*(M*i+s*e+c*u-h*o)/f,r[2]=2*(c*i+s*o+h*e-M*u)/f):(r[0]=2*(h*i+s*u+M*o-c*e),r[1]=2*(M*i+s*e+c*u-h*o),r[2]=2*(c*i+s*o+h*e-M*u)),A(t,a,r),t},getTranslation:R,getScaling:function(t,a){var n=a[0],r=a[1],u=a[2],e=a[4],o=a[5],i=a[6],h=a[8],M=a[9],c=a[10];return t[0]=Math.sqrt(n*n+r*r+u*u),t[1]=Math.sqrt(e*e+o*o+i*i),t[2]=Math.sqrt(h*h+M*M+c*c),t},getRotation:P,fromRotationTranslationScale:function(t,a,n,r){var u=a[0],e=a[1],o=a[2],i=a[3],h=u+u,M=e+e,c=o+o,s=u*h,f=u*M,l=u*c,v=e*M,b=e*c,m=o*c,d=i*h,p=i*M,x=i*c,q=r[0],w=r[1],y=r[2];return t[0]=(1-(v+m))*q,t[1]=(f+x)*q,t[2]=(l-p)*q,t[3]=0,t[4]=(f-x)*w,t[5]=(1-(s+m))*w,t[6]=(b+d)*w,t[7]=0,t[8]=(l+p)*y,t[9]=(b-d)*y,t[10]=(1-(s+v))*y,t[11]=0,t[12]=n[0],t[13]=n[1],t[14]=n[2],t[15]=1,t},fromRotationTranslationScaleOrigin:function(t,a,n,r,u){var e=a[0],o=a[1],i=a[2],h=a[3],M=e+e,c=o+o,s=i+i,f=e*M,l=e*c,v=e*s,b=o*c,m=o*s,d=i*s,p=h*M,x=h*c,q=h*s,w=r[0],y=r[1],g=r[2],A=u[0],R=u[1],P=u[2],j=(1-(b+d))*w,z=(l+q)*w,I=(v-x)*w,S=(l-q)*y,E=(1-(f+d))*y,O=(m+p)*y,T=(v+x)*g,D=(m-p)*g,F=(1-(f+b))*g;return t[0]=j,t[1]=z,t[2]=I,t[3]=0,t[4]=S,t[5]=E,t[6]=O,t[7]=0,t[8]=T,t[9]=D,t[10]=F,t[11]=0,t[12]=n[0]+A-(j*A+S*R+T*P),t[13]=n[1]+R-(z*A+E*R+D*P),t[14]=n[2]+P-(I*A+O*R+F*P),t[15]=1,t},fromQuat:function(t,a){var n=a[0],r=a[1],u=a[2],e=a[3],o=n+n,i=r+r,h=u+u,M=n*o,c=r*o,s=r*i,f=u*o,l=u*i,v=u*h,b=e*o,m=e*i,d=e*h;return t[0]=1-s-v,t[1]=c+d,t[2]=f-m,t[3]=0,t[4]=c-d,t[5]=1-M-v,t[6]=l+b,t[7]=0,t[8]=f+m,t[9]=l-b,t[10]=1-M-s,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t},frustum:function(t,a,n,r,u,e,o){var i=1/(n-a),h=1/(u-r),M=1/(e-o);return t[0]=2*e*i,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=2*e*h,t[6]=0,t[7]=0,t[8]=(n+a)*i,t[9]=(u+r)*h,t[10]=(o+e)*M,t[11]=-1,t[12]=0,t[13]=0,t[14]=o*e*2*M,t[15]=0,t},perspective:function(t,a,n,r,u){var e,o=1/Math.tan(a/2);return t[0]=o/n,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=o,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[11]=-1,t[12]=0,t[13]=0,t[15]=0,null!=u&&u!==1/0?(e=1/(r-u),t[10]=(u+r)*e,t[14]=2*u*r*e):(t[10]=-1,t[14]=-2*r),t},perspectiveFromFieldOfView:function(t,a,n,r){var u=Math.tan(a.upDegrees*Math.PI/180),e=Math.tan(a.downDegrees*Math.PI/180),o=Math.tan(a.leftDegrees*Math.PI/180),i=Math.tan(a.rightDegrees*Math.PI/180),h=2/(o+i),M=2/(u+e);return t[0]=h,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=M,t[6]=0,t[7]=0,t[8]=-(o-i)*h*.5,t[9]=(u-e)*M*.5,t[10]=r/(n-r),t[11]=-1,t[12]=0,t[13]=0,t[14]=r*n/(n-r),t[15]=0,t},ortho:function(t,a,n,r,u,e,o){var i=1/(a-n),h=1/(r-u),M=1/(e-o);return t[0]=-2*i,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=-2*h,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=2*M,t[11]=0,t[12]=(a+n)*i,t[13]=(u+r)*h,t[14]=(o+e)*M,t[15]=1,t},lookAt:function(t,n,r,u){var e,o,i,h,M,c,s,f,l,v,b=n[0],m=n[1],d=n[2],p=u[0],x=u[1],q=u[2],w=r[0],g=r[1],A=r[2];return Math.abs(b-w)<a&&Math.abs(m-g)<a&&Math.abs(d-A)<a?y(t):(s=b-w,f=m-g,l=d-A,e=x*(l*=v=1/Math.sqrt(s*s+f*f+l*l))-q*(f*=v),o=q*(s*=v)-p*l,i=p*f-x*s,(v=Math.sqrt(e*e+o*o+i*i))?(e*=v=1/v,o*=v,i*=v):(e=0,o=0,i=0),h=f*i-l*o,M=l*e-s*i,c=s*o-f*e,(v=Math.sqrt(h*h+M*M+c*c))?(h*=v=1/v,M*=v,c*=v):(h=0,M=0,c=0),t[0]=e,t[1]=h,t[2]=s,t[3]=0,t[4]=o,t[5]=M,t[6]=f,t[7]=0,t[8]=i,t[9]=c,t[10]=l,t[11]=0,t[12]=-(e*b+o*m+i*d),t[13]=-(h*b+M*m+c*d),t[14]=-(s*b+f*m+l*d),t[15]=1,t)},targetTo:function(t,a,n,r){var u=a[0],e=a[1],o=a[2],i=r[0],h=r[1],M=r[2],c=u-n[0],s=e-n[1],f=o-n[2],l=c*c+s*s+f*f;l>0&&(c*=l=1/Math.sqrt(l),s*=l,f*=l);var v=h*f-M*s,b=M*c-i*f,m=i*s-h*c;return(l=v*v+b*b+m*m)>0&&(v*=l=1/Math.sqrt(l),b*=l,m*=l),t[0]=v,t[1]=b,t[2]=m,t[3]=0,t[4]=s*m-f*b,t[5]=f*v-c*m,t[6]=c*b-s*v,t[7]=0,t[8]=c,t[9]=s,t[10]=f,t[11]=0,t[12]=u,t[13]=e,t[14]=o,t[15]=1,t},str:function(t){return"mat4("+t[0]+", "+t[1]+", "+t[2]+", "+t[3]+", "+t[4]+", "+t[5]+", "+t[6]+", "+t[7]+", "+t[8]+", "+t[9]+", "+t[10]+", "+t[11]+", "+t[12]+", "+t[13]+", "+t[14]+", "+t[15]+")"},frob:function(t){return Math.sqrt(Math.pow(t[0],2)+Math.pow(t[1],2)+Math.pow(t[2],2)+Math.pow(t[3],2)+Math.pow(t[4],2)+Math.pow(t[5],2)+Math.pow(t[6],2)+Math.pow(t[7],2)+Math.pow(t[8],2)+Math.pow(t[9],2)+Math.pow(t[10],2)+Math.pow(t[11],2)+Math.pow(t[12],2)+Math.pow(t[13],2)+Math.pow(t[14],2)+Math.pow(t[15],2))},add:function(t,a,n){return t[0]=a[0]+n[0],t[1]=a[1]+n[1],t[2]=a[2]+n[2],t[3]=a[3]+n[3],t[4]=a[4]+n[4],t[5]=a[5]+n[5],t[6]=a[6]+n[6],t[7]=a[7]+n[7],t[8]=a[8]+n[8],t[9]=a[9]+n[9],t[10]=a[10]+n[10],t[11]=a[11]+n[11],t[12]=a[12]+n[12],t[13]=a[13]+n[13],t[14]=a[14]+n[14],t[15]=a[15]+n[15],t},subtract:j,multiplyScalar:function(t,a,n){return t[0]=a[0]*n,t[1]=a[1]*n,t[2]=a[2]*n,t[3]=a[3]*n,t[4]=a[4]*n,t[5]=a[5]*n,t[6]=a[6]*n,t[7]=a[7]*n,t[8]=a[8]*n,t[9]=a[9]*n,t[10]=a[10]*n,t[11]=a[11]*n,t[12]=a[12]*n,t[13]=a[13]*n,t[14]=a[14]*n,t[15]=a[15]*n,t},multiplyScalarAndAdd:function(t,a,n,r){return t[0]=a[0]+n[0]*r,t[1]=a[1]+n[1]*r,t[2]=a[2]+n[2]*r,t[3]=a[3]+n[3]*r,t[4]=a[4]+n[4]*r,t[5]=a[5]+n[5]*r,t[6]=a[6]+n[6]*r,t[7]=a[7]+n[7]*r,t[8]=a[8]+n[8]*r,t[9]=a[9]+n[9]*r,t[10]=a[10]+n[10]*r,t[11]=a[11]+n[11]*r,t[12]=a[12]+n[12]*r,t[13]=a[13]+n[13]*r,t[14]=a[14]+n[14]*r,t[15]=a[15]+n[15]*r,t},exactEquals:function(t,a){return t[0]===a[0]&&t[1]===a[1]&&t[2]===a[2]&&t[3]===a[3]&&t[4]===a[4]&&t[5]===a[5]&&t[6]===a[6]&&t[7]===a[7]&&t[8]===a[8]&&t[9]===a[9]&&t[10]===a[10]&&t[11]===a[11]&&t[12]===a[12]&&t[13]===a[13]&&t[14]===a[14]&&t[15]===a[15]},equals:function(t,n){var r=t[0],u=t[1],e=t[2],o=t[3],i=t[4],h=t[5],M=t[6],c=t[7],s=t[8],f=t[9],l=t[10],v=t[11],b=t[12],m=t[13],d=t[14],p=t[15],x=n[0],q=n[1],w=n[2],y=n[3],g=n[4],A=n[5],R=n[6],P=n[7],j=n[8],z=n[9],I=n[10],S=n[11],E=n[12],O=n[13],T=n[14],D=n[15];return Math.abs(r-x)<=a*Math.max(1,Math.abs(r),Math.abs(x))&&Math.abs(u-q)<=a*Math.max(1,Math.abs(u),Math.abs(q))&&Math.abs(e-w)<=a*Math.max(1,Math.abs(e),Math.abs(w))&&Math.abs(o-y)<=a*Math.max(1,Math.abs(o),Math.abs(y))&&Math.abs(i-g)<=a*Math.max(1,Math.abs(i),Math.abs(g))&&Math.abs(h-A)<=a*Math.max(1,Math.abs(h),Math.abs(A))&&Math.abs(M-R)<=a*Math.max(1,Math.abs(M),Math.abs(R))&&Math.abs(c-P)<=a*Math.max(1,Math.abs(c),Math.abs(P))&&Math.abs(s-j)<=a*Math.max(1,Math.abs(s),Math.abs(j))&&Math.abs(f-z)<=a*Math.max(1,Math.abs(f),Math.abs(z))&&Math.abs(l-I)<=a*Math.max(1,Math.abs(l),Math.abs(I))&&Math.abs(v-S)<=a*Math.max(1,Math.abs(v),Math.abs(S))&&Math.abs(b-E)<=a*Math.max(1,Math.abs(b),Math.abs(E))&&Math.abs(m-O)<=a*Math.max(1,Math.abs(m),Math.abs(O))&&Math.abs(d-T)<=a*Math.max(1,Math.abs(d),Math.abs(T))&&Math.abs(p-D)<=a*Math.max(1,Math.abs(p),Math.abs(D))},mul:z,sub:I});function E(){var t=new n(3);return n!=Float32Array&&(t[0]=0,t[1]=0,t[2]=0),t}function O(t){var a=t[0],n=t[1],r=t[2];return Math.sqrt(a*a+n*n+r*r)}function T(t,a,r){var u=new n(3);return u[0]=t,u[1]=a,u[2]=r,u}function D(t,a,n){return t[0]=a[0]-n[0],t[1]=a[1]-n[1],t[2]=a[2]-n[2],t}function F(t,a,n){return t[0]=a[0]*n[0],t[1]=a[1]*n[1],t[2]=a[2]*n[2],t}function L(t,a,n){return t[0]=a[0]/n[0],t[1]=a[1]/n[1],t[2]=a[2]/n[2],t}function V(t,a){var n=a[0]-t[0],r=a[1]-t[1],u=a[2]-t[2];return Math.sqrt(n*n+r*r+u*u)}function Q(t,a){var n=a[0]-t[0],r=a[1]-t[1],u=a[2]-t[2];return n*n+r*r+u*u}function Y(t){var a=t[0],n=t[1],r=t[2];return a*a+n*n+r*r}function X(t,a){var n=a[0],r=a[1],u=a[2],e=n*n+r*r+u*u;return e>0&&(e=1/Math.sqrt(e)),t[0]=a[0]*e,t[1]=a[1]*e,t[2]=a[2]*e,t}function Z(t,a){return t[0]*a[0]+t[1]*a[1]+t[2]*a[2]}function _(t,a,n){var r=a[0],u=a[1],e=a[2],o=n[0],i=n[1],h=n[2];return t[0]=u*h-e*i,t[1]=e*o-r*h,t[2]=r*i-u*o,t}var B,N=D,k=F,U=L,W=V,C=Q,G=O,H=Y,J=(B=E(),function(t,a,n,r,u,e){var o,i;for(a||(a=3),n||(n=0),i=r?Math.min(r*a+n,t.length):t.length,o=n;o<i;o+=a)B[0]=t[o],B[1]=t[o+1],B[2]=t[o+2],u(B,B,e),t[o]=B[0],t[o+1]=B[1],t[o+2]=B[2];return t}),K=Object.freeze({create:E,clone:function(t){var a=new n(3);return a[0]=t[0],a[1]=t[1],a[2]=t[2],a},length:O,fromValues:T,copy:function(t,a){return t[0]=a[0],t[1]=a[1],t[2]=a[2],t},set:function(t,a,n,r){return t[0]=a,t[1]=n,t[2]=r,t},add:function(t,a,n){return t[0]=a[0]+n[0],t[1]=a[1]+n[1],t[2]=a[2]+n[2],t},subtract:D,multiply:F,divide:L,ceil:function(t,a){return t[0]=Math.ceil(a[0]),t[1]=Math.ceil(a[1]),t[2]=Math.ceil(a[2]),t},floor:function(t,a){return t[0]=Math.floor(a[0]),t[1]=Math.floor(a[1]),t[2]=Math.floor(a[2]),t},min:function(t,a,n){return t[0]=Math.min(a[0],n[0]),t[1]=Math.min(a[1],n[1]),t[2]=Math.min(a[2],n[2]),t},max:function(t,a,n){return t[0]=Math.max(a[0],n[0]),t[1]=Math.max(a[1],n[1]),t[2]=Math.max(a[2],n[2]),t},round:function(t,a){return t[0]=Math.round(a[0]),t[1]=Math.round(a[1]),t[2]=Math.round(a[2]),t},scale:function(t,a,n){return t[0]=a[0]*n,t[1]=a[1]*n,t[2]=a[2]*n,t},scaleAndAdd:function(t,a,n,r){return t[0]=a[0]+n[0]*r,t[1]=a[1]+n[1]*r,t[2]=a[2]+n[2]*r,t},distance:V,squaredDistance:Q,squaredLength:Y,negate:function(t,a){return t[0]=-a[0],t[1]=-a[1],t[2]=-a[2],t},inverse:function(t,a){return t[0]=1/a[0],t[1]=1/a[1],t[2]=1/a[2],t},normalize:X,dot:Z,cross:_,lerp:function(t,a,n,r){var u=a[0],e=a[1],o=a[2];return t[0]=u+r*(n[0]-u),t[1]=e+r*(n[1]-e),t[2]=o+r*(n[2]-o),t},hermite:function(t,a,n,r,u,e){var o=e*e,i=o*(2*e-3)+1,h=o*(e-2)+e,M=o*(e-1),c=o*(3-2*e);return t[0]=a[0]*i+n[0]*h+r[0]*M+u[0]*c,t[1]=a[1]*i+n[1]*h+r[1]*M+u[1]*c,t[2]=a[2]*i+n[2]*h+r[2]*M+u[2]*c,t},bezier:function(t,a,n,r,u,e){var o=1-e,i=o*o,h=e*e,M=i*o,c=3*e*i,s=3*h*o,f=h*e;return t[0]=a[0]*M+n[0]*c+r[0]*s+u[0]*f,t[1]=a[1]*M+n[1]*c+r[1]*s+u[1]*f,t[2]=a[2]*M+n[2]*c+r[2]*s+u[2]*f,t},random:function(t,a){a=a||1;var n=2*r()*Math.PI,u=2*r()-1,e=Math.sqrt(1-u*u)*a;return t[0]=Math.cos(n)*e,t[1]=Math.sin(n)*e,t[2]=u*a,t},transformMat4:function(t,a,n){var r=a[0],u=a[1],e=a[2],o=n[3]*r+n[7]*u+n[11]*e+n[15];return o=o||1,t[0]=(n[0]*r+n[4]*u+n[8]*e+n[12])/o,t[1]=(n[1]*r+n[5]*u+n[9]*e+n[13])/o,t[2]=(n[2]*r+n[6]*u+n[10]*e+n[14])/o,t},transformMat3:function(t,a,n){var r=a[0],u=a[1],e=a[2];return t[0]=r*n[0]+u*n[3]+e*n[6],t[1]=r*n[1]+u*n[4]+e*n[7],t[2]=r*n[2]+u*n[5]+e*n[8],t},transformQuat:function(t,a,n){var r=n[0],u=n[1],e=n[2],o=n[3],i=a[0],h=a[1],M=a[2],c=u*M-e*h,s=e*i-r*M,f=r*h-u*i,l=u*f-e*s,v=e*c-r*f,b=r*s-u*c,m=2*o;return c*=m,s*=m,f*=m,l*=2,v*=2,b*=2,t[0]=i+c+l,t[1]=h+s+v,t[2]=M+f+b,t},rotateX:function(t,a,n,r){var u=[],e=[];return u[0]=a[0]-n[0],u[1]=a[1]-n[1],u[2]=a[2]-n[2],e[0]=u[0],e[1]=u[1]*Math.cos(r)-u[2]*Math.sin(r),e[2]=u[1]*Math.sin(r)+u[2]*Math.cos(r),t[0]=e[0]+n[0],t[1]=e[1]+n[1],t[2]=e[2]+n[2],t},rotateY:function(t,a,n,r){var u=[],e=[];return u[0]=a[0]-n[0],u[1]=a[1]-n[1],u[2]=a[2]-n[2],e[0]=u[2]*Math.sin(r)+u[0]*Math.cos(r),e[1]=u[1],e[2]=u[2]*Math.cos(r)-u[0]*Math.sin(r),t[0]=e[0]+n[0],t[1]=e[1]+n[1],t[2]=e[2]+n[2],t},rotateZ:function(t,a,n,r){var u=[],e=[];return u[0]=a[0]-n[0],u[1]=a[1]-n[1],u[2]=a[2]-n[2],e[0]=u[0]*Math.cos(r)-u[1]*Math.sin(r),e[1]=u[0]*Math.sin(r)+u[1]*Math.cos(r),e[2]=u[2],t[0]=e[0]+n[0],t[1]=e[1]+n[1],t[2]=e[2]+n[2],t},angle:function(t,a){var n=T(t[0],t[1],t[2]),r=T(a[0],a[1],a[2]);X(n,n),X(r,r);var u=Z(n,r);return u>1?0:u<-1?Math.PI:Math.acos(u)},str:function(t){return"vec3("+t[0]+", "+t[1]+", "+t[2]+")"},exactEquals:function(t,a){return t[0]===a[0]&&t[1]===a[1]&&t[2]===a[2]},equals:function(t,n){var r=t[0],u=t[1],e=t[2],o=n[0],i=n[1],h=n[2];return Math.abs(r-o)<=a*Math.max(1,Math.abs(r),Math.abs(o))&&Math.abs(u-i)<=a*Math.max(1,Math.abs(u),Math.abs(i))&&Math.abs(e-h)<=a*Math.max(1,Math.abs(e),Math.abs(h))},sub:N,mul:k,div:U,dist:W,sqrDist:C,len:G,sqrLen:H,forEach:J});function $(){var t=new n(4);return n!=Float32Array&&(t[0]=0,t[1]=0,t[2]=0,t[3]=0),t}function tt(t){var a=new n(4);return a[0]=t[0],a[1]=t[1],a[2]=t[2],a[3]=t[3],a}function at(t,a,r,u){var e=new n(4);return e[0]=t,e[1]=a,e[2]=r,e[3]=u,e}function nt(t,a){return t[0]=a[0],t[1]=a[1],t[2]=a[2],t[3]=a[3],t}function rt(t,a,n,r,u){return t[0]=a,t[1]=n,t[2]=r,t[3]=u,t}function ut(t,a,n){return t[0]=a[0]+n[0],t[1]=a[1]+n[1],t[2]=a[2]+n[2],t[3]=a[3]+n[3],t}function et(t,a,n){return t[0]=a[0]-n[0],t[1]=a[1]-n[1],t[2]=a[2]-n[2],t[3]=a[3]-n[3],t}function ot(t,a,n){return t[0]=a[0]*n[0],t[1]=a[1]*n[1],t[2]=a[2]*n[2],t[3]=a[3]*n[3],t}function it(t,a,n){return t[0]=a[0]/n[0],t[1]=a[1]/n[1],t[2]=a[2]/n[2],t[3]=a[3]/n[3],t}function ht(t,a,n){return t[0]=a[0]*n,t[1]=a[1]*n,t[2]=a[2]*n,t[3]=a[3]*n,t}function Mt(t,a){var n=a[0]-t[0],r=a[1]-t[1],u=a[2]-t[2],e=a[3]-t[3];return Math.sqrt(n*n+r*r+u*u+e*e)}function ct(t,a){var n=a[0]-t[0],r=a[1]-t[1],u=a[2]-t[2],e=a[3]-t[3];return n*n+r*r+u*u+e*e}function st(t){var a=t[0],n=t[1],r=t[2],u=t[3];return Math.sqrt(a*a+n*n+r*r+u*u)}function ft(t){var a=t[0],n=t[1],r=t[2],u=t[3];return a*a+n*n+r*r+u*u}function lt(t,a){var n=a[0],r=a[1],u=a[2],e=a[3],o=n*n+r*r+u*u+e*e;return o>0&&(o=1/Math.sqrt(o)),t[0]=n*o,t[1]=r*o,t[2]=u*o,t[3]=e*o,t}function vt(t,a){return t[0]*a[0]+t[1]*a[1]+t[2]*a[2]+t[3]*a[3]}function bt(t,a,n,r){var u=a[0],e=a[1],o=a[2],i=a[3];return t[0]=u+r*(n[0]-u),t[1]=e+r*(n[1]-e),t[2]=o+r*(n[2]-o),t[3]=i+r*(n[3]-i),t}function mt(t,a){return t[0]===a[0]&&t[1]===a[1]&&t[2]===a[2]&&t[3]===a[3]}function dt(t,n){var r=t[0],u=t[1],e=t[2],o=t[3],i=n[0],h=n[1],M=n[2],c=n[3];return Math.abs(r-i)<=a*Math.max(1,Math.abs(r),Math.abs(i))&&Math.abs(u-h)<=a*Math.max(1,Math.abs(u),Math.abs(h))&&Math.abs(e-M)<=a*Math.max(1,Math.abs(e),Math.abs(M))&&Math.abs(o-c)<=a*Math.max(1,Math.abs(o),Math.abs(c))}var pt=et,xt=ot,qt=it,wt=Mt,yt=ct,gt=st,At=ft,Rt=function(){var t=$();return function(a,n,r,u,e,o){var i,h;for(n||(n=4),r||(r=0),h=u?Math.min(u*n+r,a.length):a.length,i=r;i<h;i+=n)t[0]=a[i],t[1]=a[i+1],t[2]=a[i+2],t[3]=a[i+3],e(t,t,o),a[i]=t[0],a[i+1]=t[1],a[i+2]=t[2],a[i+3]=t[3];return a}}(),Pt=Object.freeze({create:$,clone:tt,fromValues:at,copy:nt,set:rt,add:ut,subtract:et,multiply:ot,divide:it,ceil:function(t,a){return t[0]=Math.ceil(a[0]),t[1]=Math.ceil(a[1]),t[2]=Math.ceil(a[2]),t[3]=Math.ceil(a[3]),t},floor:function(t,a){return t[0]=Math.floor(a[0]),t[1]=Math.floor(a[1]),t[2]=Math.floor(a[2]),t[3]=Math.floor(a[3]),t},min:function(t,a,n){return t[0]=Math.min(a[0],n[0]),t[1]=Math.min(a[1],n[1]),t[2]=Math.min(a[2],n[2]),t[3]=Math.min(a[3],n[3]),t},max:function(t,a,n){return t[0]=Math.max(a[0],n[0]),t[1]=Math.max(a[1],n[1]),t[2]=Math.max(a[2],n[2]),t[3]=Math.max(a[3],n[3]),t},round:function(t,a){return t[0]=Math.round(a[0]),t[1]=Math.round(a[1]),t[2]=Math.round(a[2]),t[3]=Math.round(a[3]),t},scale:ht,scaleAndAdd:function(t,a,n,r){return t[0]=a[0]+n[0]*r,t[1]=a[1]+n[1]*r,t[2]=a[2]+n[2]*r,t[3]=a[3]+n[3]*r,t},distance:Mt,squaredDistance:ct,length:st,squaredLength:ft,negate:function(t,a){return t[0]=-a[0],t[1]=-a[1],t[2]=-a[2],t[3]=-a[3],t},inverse:function(t,a){return t[0]=1/a[0],t[1]=1/a[1],t[2]=1/a[2],t[3]=1/a[3],t},normalize:lt,dot:vt,lerp:bt,random:function(t,a){var n,u,e,o,i,h;a=a||1;do{i=(n=2*r()-1)*n+(u=2*r()-1)*u}while(i>=1);do{h=(e=2*r()-1)*e+(o=2*r()-1)*o}while(h>=1);var M=Math.sqrt((1-i)/h);return t[0]=a*n,t[1]=a*u,t[2]=a*e*M,t[3]=a*o*M,t},transformMat4:function(t,a,n){var r=a[0],u=a[1],e=a[2],o=a[3];return t[0]=n[0]*r+n[4]*u+n[8]*e+n[12]*o,t[1]=n[1]*r+n[5]*u+n[9]*e+n[13]*o,t[2]=n[2]*r+n[6]*u+n[10]*e+n[14]*o,t[3]=n[3]*r+n[7]*u+n[11]*e+n[15]*o,t},transformQuat:function(t,a,n){var r=a[0],u=a[1],e=a[2],o=n[0],i=n[1],h=n[2],M=n[3],c=M*r+i*e-h*u,s=M*u+h*r-o*e,f=M*e+o*u-i*r,l=-o*r-i*u-h*e;return t[0]=c*M+l*-o+s*-h-f*-i,t[1]=s*M+l*-i+f*-o-c*-h,t[2]=f*M+l*-h+c*-i-s*-o,t[3]=a[3],t},str:function(t){return"vec4("+t[0]+", "+t[1]+", "+t[2]+", "+t[3]+")"},exactEquals:mt,equals:dt,sub:pt,mul:xt,div:qt,dist:wt,sqrDist:yt,len:gt,sqrLen:At,forEach:Rt});function jt(){var t=new n(4);return n!=Float32Array&&(t[0]=0,t[1]=0,t[2]=0),t[3]=1,t}function zt(t,a,n){n*=.5;var r=Math.sin(n);return t[0]=r*a[0],t[1]=r*a[1],t[2]=r*a[2],t[3]=Math.cos(n),t}function It(t,a,n){var r=a[0],u=a[1],e=a[2],o=a[3],i=n[0],h=n[1],M=n[2],c=n[3];return t[0]=r*c+o*i+u*M-e*h,t[1]=u*c+o*h+e*i-r*M,t[2]=e*c+o*M+r*h-u*i,t[3]=o*c-r*i-u*h-e*M,t}function St(t,a,n){n*=.5;var r=a[0],u=a[1],e=a[2],o=a[3],i=Math.sin(n),h=Math.cos(n);return t[0]=r*h+o*i,t[1]=u*h+e*i,t[2]=e*h-u*i,t[3]=o*h-r*i,t}function Et(t,a,n){n*=.5;var r=a[0],u=a[1],e=a[2],o=a[3],i=Math.sin(n),h=Math.cos(n);return t[0]=r*h-e*i,t[1]=u*h+o*i,t[2]=e*h+r*i,t[3]=o*h-u*i,t}function Ot(t,a,n){n*=.5;var r=a[0],u=a[1],e=a[2],o=a[3],i=Math.sin(n),h=Math.cos(n);return t[0]=r*h+u*i,t[1]=u*h-r*i,t[2]=e*h+o*i,t[3]=o*h-e*i,t}function Tt(t,n,r,u){var e,o,i,h,M,c=n[0],s=n[1],f=n[2],l=n[3],v=r[0],b=r[1],m=r[2],d=r[3];return(o=c*v+s*b+f*m+l*d)<0&&(o=-o,v=-v,b=-b,m=-m,d=-d),1-o>a?(e=Math.acos(o),i=Math.sin(e),h=Math.sin((1-u)*e)/i,M=Math.sin(u*e)/i):(h=1-u,M=u),t[0]=h*c+M*v,t[1]=h*s+M*b,t[2]=h*f+M*m,t[3]=h*l+M*d,t}function Dt(t,a){var n,r=a[0]+a[4]+a[8];if(r>0)n=Math.sqrt(r+1),t[3]=.5*n,n=.5/n,t[0]=(a[5]-a[7])*n,t[1]=(a[6]-a[2])*n,t[2]=(a[1]-a[3])*n;else{var u=0;a[4]>a[0]&&(u=1),a[8]>a[3*u+u]&&(u=2);var e=(u+1)%3,o=(u+2)%3;n=Math.sqrt(a[3*u+u]-a[3*e+e]-a[3*o+o]+1),t[u]=.5*n,n=.5/n,t[3]=(a[3*e+o]-a[3*o+e])*n,t[e]=(a[3*e+u]+a[3*u+e])*n,t[o]=(a[3*o+u]+a[3*u+o])*n}return t}var Ft,Lt,Vt,Qt,Yt,Xt,Zt=tt,_t=at,Bt=nt,Nt=rt,kt=ut,Ut=It,Wt=ht,Ct=vt,Gt=bt,Ht=st,Jt=Ht,Kt=ft,$t=Kt,ta=lt,aa=mt,na=dt,ra=(Ft=E(),Lt=T(1,0,0),Vt=T(0,1,0),function(t,a,n){var r=Z(a,n);return r<-.999999?(_(Ft,Lt,a),G(Ft)<1e-6&&_(Ft,Vt,a),X(Ft,Ft),zt(t,Ft,Math.PI),t):r>.999999?(t[0]=0,t[1]=0,t[2]=0,t[3]=1,t):(_(Ft,a,n),t[0]=Ft[0],t[1]=Ft[1],t[2]=Ft[2],t[3]=1+r,ta(t,t))}),ua=(Qt=jt(),Yt=jt(),function(t,a,n,r,u,e){return Tt(Qt,a,u,e),Tt(Yt,n,r,e),Tt(t,Qt,Yt,2*e*(1-e)),t}),ea=(Xt=m(),function(t,a,n,r){return Xt[0]=n[0],Xt[3]=n[1],Xt[6]=n[2],Xt[1]=r[0],Xt[4]=r[1],Xt[7]=r[2],Xt[2]=-a[0],Xt[5]=-a[1],Xt[8]=-a[2],ta(t,Dt(t,Xt))}),oa=Object.freeze({create:jt,identity:function(t){return t[0]=0,t[1]=0,t[2]=0,t[3]=1,t},setAxisAngle:zt,getAxisAngle:function(t,n){var r=2*Math.acos(n[3]),u=Math.sin(r/2);return u>a?(t[0]=n[0]/u,t[1]=n[1]/u,t[2]=n[2]/u):(t[0]=1,t[1]=0,t[2]=0),r},multiply:It,rotateX:St,rotateY:Et,rotateZ:Ot,calculateW:function(t,a){var n=a[0],r=a[1],u=a[2];return t[0]=n,t[1]=r,t[2]=u,t[3]=Math.sqrt(Math.abs(1-n*n-r*r-u*u)),t},slerp:Tt,random:function(t){var a=r(),n=r(),u=r(),e=Math.sqrt(1-a),o=Math.sqrt(a);return t[0]=e*Math.sin(2*Math.PI*n),t[1]=e*Math.cos(2*Math.PI*n),t[2]=o*Math.sin(2*Math.PI*u),t[3]=o*Math.cos(2*Math.PI*u),t},invert:function(t,a){var n=a[0],r=a[1],u=a[2],e=a[3],o=n*n+r*r+u*u+e*e,i=o?1/o:0;return t[0]=-n*i,t[1]=-r*i,t[2]=-u*i,t[3]=e*i,t},conjugate:function(t,a){return t[0]=-a[0],t[1]=-a[1],t[2]=-a[2],t[3]=a[3],t},fromMat3:Dt,fromEuler:function(t,a,n,r){var u=.5*Math.PI/180;a*=u,n*=u,r*=u;var e=Math.sin(a),o=Math.cos(a),i=Math.sin(n),h=Math.cos(n),M=Math.sin(r),c=Math.cos(r);return t[0]=e*h*c-o*i*M,t[1]=o*i*c+e*h*M,t[2]=o*h*M-e*i*c,t[3]=o*h*c+e*i*M,t},str:function(t){return"quat("+t[0]+", "+t[1]+", "+t[2]+", "+t[3]+")"},clone:Zt,fromValues:_t,copy:Bt,set:Nt,add:kt,mul:Ut,scale:Wt,dot:Ct,lerp:Gt,length:Ht,len:Jt,squaredLength:Kt,sqrLen:$t,normalize:ta,exactEquals:aa,equals:na,rotationTo:ra,sqlerp:ua,setAxes:ea});function ia(t,a,n){var r=.5*n[0],u=.5*n[1],e=.5*n[2],o=a[0],i=a[1],h=a[2],M=a[3];return t[0]=o,t[1]=i,t[2]=h,t[3]=M,t[4]=r*M+u*h-e*i,t[5]=u*M+e*o-r*h,t[6]=e*M+r*i-u*o,t[7]=-r*o-u*i-e*h,t}function ha(t,a){return t[0]=a[0],t[1]=a[1],t[2]=a[2],t[3]=a[3],t[4]=a[4],t[5]=a[5],t[6]=a[6],t[7]=a[7],t}var Ma=Bt;var ca=Bt;function sa(t,a,n){var r=a[0],u=a[1],e=a[2],o=a[3],i=n[4],h=n[5],M=n[6],c=n[7],s=a[4],f=a[5],l=a[6],v=a[7],b=n[0],m=n[1],d=n[2],p=n[3];return t[0]=r*p+o*b+u*d-e*m,t[1]=u*p+o*m+e*b-r*d,t[2]=e*p+o*d+r*m-u*b,t[3]=o*p-r*b-u*m-e*d,t[4]=r*c+o*i+u*M-e*h+s*p+v*b+f*d-l*m,t[5]=u*c+o*h+e*i-r*M+f*p+v*m+l*b-s*d,t[6]=e*c+o*M+r*h-u*i+l*p+v*d+s*m-f*b,t[7]=o*c-r*i-u*h-e*M+v*p-s*b-f*m-l*d,t}var fa=sa;var la=Ct;var va=Ht,ba=va,ma=Kt,da=ma;var pa=Object.freeze({create:function(){var t=new n(8);return n!=Float32Array&&(t[0]=0,t[1]=0,t[2]=0,t[4]=0,t[5]=0,t[6]=0,t[7]=0),t[3]=1,t},clone:function(t){var a=new n(8);return a[0]=t[0],a[1]=t[1],a[2]=t[2],a[3]=t[3],a[4]=t[4],a[5]=t[5],a[6]=t[6],a[7]=t[7],a},fromValues:function(t,a,r,u,e,o,i,h){var M=new n(8);return M[0]=t,M[1]=a,M[2]=r,M[3]=u,M[4]=e,M[5]=o,M[6]=i,M[7]=h,M},fromRotationTranslationValues:function(t,a,r,u,e,o,i){var h=new n(8);h[0]=t,h[1]=a,h[2]=r,h[3]=u;var M=.5*e,c=.5*o,s=.5*i;return h[4]=M*u+c*r-s*a,h[5]=c*u+s*t-M*r,h[6]=s*u+M*a-c*t,h[7]=-M*t-c*a-s*r,h},fromRotationTranslation:ia,fromTranslation:function(t,a){return t[0]=0,t[1]=0,t[2]=0,t[3]=1,t[4]=.5*a[0],t[5]=.5*a[1],t[6]=.5*a[2],t[7]=0,t},fromRotation:function(t,a){return t[0]=a[0],t[1]=a[1],t[2]=a[2],t[3]=a[3],t[4]=0,t[5]=0,t[6]=0,t[7]=0,t},fromMat4:function(t,a){var r=jt();P(r,a);var u=new n(3);return R(u,a),ia(t,r,u),t},copy:ha,identity:function(t){return t[0]=0,t[1]=0,t[2]=0,t[3]=1,t[4]=0,t[5]=0,t[6]=0,t[7]=0,t},set:function(t,a,n,r,u,e,o,i,h){return t[0]=a,t[1]=n,t[2]=r,t[3]=u,t[4]=e,t[5]=o,t[6]=i,t[7]=h,t},getReal:Ma,getDual:function(t,a){return t[0]=a[4],t[1]=a[5],t[2]=a[6],t[3]=a[7],t},setReal:ca,setDual:function(t,a){return t[4]=a[0],t[5]=a[1],t[6]=a[2],t[7]=a[3],t},getTranslation:function(t,a){var n=a[4],r=a[5],u=a[6],e=a[7],o=-a[0],i=-a[1],h=-a[2],M=a[3];return t[0]=2*(n*M+e*o+r*h-u*i),t[1]=2*(r*M+e*i+u*o-n*h),t[2]=2*(u*M+e*h+n*i-r*o),t},translate:function(t,a,n){var r=a[0],u=a[1],e=a[2],o=a[3],i=.5*n[0],h=.5*n[1],M=.5*n[2],c=a[4],s=a[5],f=a[6],l=a[7];return t[0]=r,t[1]=u,t[2]=e,t[3]=o,t[4]=o*i+u*M-e*h+c,t[5]=o*h+e*i-r*M+s,t[6]=o*M+r*h-u*i+f,t[7]=-r*i-u*h-e*M+l,t},rotateX:function(t,a,n){var r=-a[0],u=-a[1],e=-a[2],o=a[3],i=a[4],h=a[5],M=a[6],c=a[7],s=i*o+c*r+h*e-M*u,f=h*o+c*u+M*r-i*e,l=M*o+c*e+i*u-h*r,v=c*o-i*r-h*u-M*e;return St(t,a,n),r=t[0],u=t[1],e=t[2],o=t[3],t[4]=s*o+v*r+f*e-l*u,t[5]=f*o+v*u+l*r-s*e,t[6]=l*o+v*e+s*u-f*r,t[7]=v*o-s*r-f*u-l*e,t},rotateY:function(t,a,n){var r=-a[0],u=-a[1],e=-a[2],o=a[3],i=a[4],h=a[5],M=a[6],c=a[7],s=i*o+c*r+h*e-M*u,f=h*o+c*u+M*r-i*e,l=M*o+c*e+i*u-h*r,v=c*o-i*r-h*u-M*e;return Et(t,a,n),r=t[0],u=t[1],e=t[2],o=t[3],t[4]=s*o+v*r+f*e-l*u,t[5]=f*o+v*u+l*r-s*e,t[6]=l*o+v*e+s*u-f*r,t[7]=v*o-s*r-f*u-l*e,t},rotateZ:function(t,a,n){var r=-a[0],u=-a[1],e=-a[2],o=a[3],i=a[4],h=a[5],M=a[6],c=a[7],s=i*o+c*r+h*e-M*u,f=h*o+c*u+M*r-i*e,l=M*o+c*e+i*u-h*r,v=c*o-i*r-h*u-M*e;return Ot(t,a,n),r=t[0],u=t[1],e=t[2],o=t[3],t[4]=s*o+v*r+f*e-l*u,t[5]=f*o+v*u+l*r-s*e,t[6]=l*o+v*e+s*u-f*r,t[7]=v*o-s*r-f*u-l*e,t},rotateByQuatAppend:function(t,a,n){var r=n[0],u=n[1],e=n[2],o=n[3],i=a[0],h=a[1],M=a[2],c=a[3];return t[0]=i*o+c*r+h*e-M*u,t[1]=h*o+c*u+M*r-i*e,t[2]=M*o+c*e+i*u-h*r,t[3]=c*o-i*r-h*u-M*e,i=a[4],h=a[5],M=a[6],c=a[7],t[4]=i*o+c*r+h*e-M*u,t[5]=h*o+c*u+M*r-i*e,t[6]=M*o+c*e+i*u-h*r,t[7]=c*o-i*r-h*u-M*e,t},rotateByQuatPrepend:function(t,a,n){var r=a[0],u=a[1],e=a[2],o=a[3],i=n[0],h=n[1],M=n[2],c=n[3];return t[0]=r*c+o*i+u*M-e*h,t[1]=u*c+o*h+e*i-r*M,t[2]=e*c+o*M+r*h-u*i,t[3]=o*c-r*i-u*h-e*M,i=n[4],h=n[5],M=n[6],c=n[7],t[4]=r*c+o*i+u*M-e*h,t[5]=u*c+o*h+e*i-r*M,t[6]=e*c+o*M+r*h-u*i,t[7]=o*c-r*i-u*h-e*M,t},rotateAroundAxis:function(t,n,r,u){if(Math.abs(u)<a)return ha(t,n);var e=Math.sqrt(r[0]*r[0]+r[1]*r[1]+r[2]*r[2]);u*=.5;var o=Math.sin(u),i=o*r[0]/e,h=o*r[1]/e,M=o*r[2]/e,c=Math.cos(u),s=n[0],f=n[1],l=n[2],v=n[3];t[0]=s*c+v*i+f*M-l*h,t[1]=f*c+v*h+l*i-s*M,t[2]=l*c+v*M+s*h-f*i,t[3]=v*c-s*i-f*h-l*M;var b=n[4],m=n[5],d=n[6],p=n[7];return t[4]=b*c+p*i+m*M-d*h,t[5]=m*c+p*h+d*i-b*M,t[6]=d*c+p*M+b*h-m*i,t[7]=p*c-b*i-m*h-d*M,t},add:function(t,a,n){return t[0]=a[0]+n[0],t[1]=a[1]+n[1],t[2]=a[2]+n[2],t[3]=a[3]+n[3],t[4]=a[4]+n[4],t[5]=a[5]+n[5],t[6]=a[6]+n[6],t[7]=a[7]+n[7],t},multiply:sa,mul:fa,scale:function(t,a,n){return t[0]=a[0]*n,t[1]=a[1]*n,t[2]=a[2]*n,t[3]=a[3]*n,t[4]=a[4]*n,t[5]=a[5]*n,t[6]=a[6]*n,t[7]=a[7]*n,t},dot:la,lerp:function(t,a,n,r){var u=1-r;return la(a,n)<0&&(r=-r),t[0]=a[0]*u+n[0]*r,t[1]=a[1]*u+n[1]*r,t[2]=a[2]*u+n[2]*r,t[3]=a[3]*u+n[3]*r,t[4]=a[4]*u+n[4]*r,t[5]=a[5]*u+n[5]*r,t[6]=a[6]*u+n[6]*r,t[7]=a[7]*u+n[7]*r,t},invert:function(t,a){var n=ma(a);return t[0]=-a[0]/n,t[1]=-a[1]/n,t[2]=-a[2]/n,t[3]=a[3]/n,t[4]=-a[4]/n,t[5]=-a[5]/n,t[6]=-a[6]/n,t[7]=a[7]/n,t},conjugate:function(t,a){return t[0]=-a[0],t[1]=-a[1],t[2]=-a[2],t[3]=a[3],t[4]=-a[4],t[5]=-a[5],t[6]=-a[6],t[7]=a[7],t},length:va,len:ba,squaredLength:ma,sqrLen:da,normalize:function(t,a){var n=ma(a);if(n>0){n=Math.sqrt(n);var r=a[0]/n,u=a[1]/n,e=a[2]/n,o=a[3]/n,i=a[4],h=a[5],M=a[6],c=a[7],s=r*i+u*h+e*M+o*c;t[0]=r,t[1]=u,t[2]=e,t[3]=o,t[4]=(i-r*s)/n,t[5]=(h-u*s)/n,t[6]=(M-e*s)/n,t[7]=(c-o*s)/n}return t},str:function(t){return"quat2("+t[0]+", "+t[1]+", "+t[2]+", "+t[3]+", "+t[4]+", "+t[5]+", "+t[6]+", "+t[7]+")"},exactEquals:function(t,a){return t[0]===a[0]&&t[1]===a[1]&&t[2]===a[2]&&t[3]===a[3]&&t[4]===a[4]&&t[5]===a[5]&&t[6]===a[6]&&t[7]===a[7]},equals:function(t,n){var r=t[0],u=t[1],e=t[2],o=t[3],i=t[4],h=t[5],M=t[6],c=t[7],s=n[0],f=n[1],l=n[2],v=n[3],b=n[4],m=n[5],d=n[6],p=n[7];return Math.abs(r-s)<=a*Math.max(1,Math.abs(r),Math.abs(s))&&Math.abs(u-f)<=a*Math.max(1,Math.abs(u),Math.abs(f))&&Math.abs(e-l)<=a*Math.max(1,Math.abs(e),Math.abs(l))&&Math.abs(o-v)<=a*Math.max(1,Math.abs(o),Math.abs(v))&&Math.abs(i-b)<=a*Math.max(1,Math.abs(i),Math.abs(b))&&Math.abs(h-m)<=a*Math.max(1,Math.abs(h),Math.abs(m))&&Math.abs(M-d)<=a*Math.max(1,Math.abs(M),Math.abs(d))&&Math.abs(c-p)<=a*Math.max(1,Math.abs(c),Math.abs(p))}});function xa(){var t=new n(2);return n!=Float32Array&&(t[0]=0,t[1]=0),t}function qa(t,a,n){return t[0]=a[0]-n[0],t[1]=a[1]-n[1],t}function wa(t,a,n){return t[0]=a[0]*n[0],t[1]=a[1]*n[1],t}function ya(t,a,n){return t[0]=a[0]/n[0],t[1]=a[1]/n[1],t}function ga(t,a){var n=a[0]-t[0],r=a[1]-t[1];return Math.sqrt(n*n+r*r)}function Aa(t,a){var n=a[0]-t[0],r=a[1]-t[1];return n*n+r*r}function Ra(t){var a=t[0],n=t[1];return Math.sqrt(a*a+n*n)}function Pa(t){var a=t[0],n=t[1];return a*a+n*n}var ja=Ra,za=qa,Ia=wa,Sa=ya,Ea=ga,Oa=Aa,Ta=Pa,Da=function(){var t=xa();return function(a,n,r,u,e,o){var i,h;for(n||(n=2),r||(r=0),h=u?Math.min(u*n+r,a.length):a.length,i=r;i<h;i+=n)t[0]=a[i],t[1]=a[i+1],e(t,t,o),a[i]=t[0],a[i+1]=t[1];return a}}(),Fa=Object.freeze({create:xa,clone:function(t){var a=new n(2);return a[0]=t[0],a[1]=t[1],a},fromValues:function(t,a){var r=new n(2);return r[0]=t,r[1]=a,r},copy:function(t,a){return t[0]=a[0],t[1]=a[1],t},set:function(t,a,n){return t[0]=a,t[1]=n,t},add:function(t,a,n){return t[0]=a[0]+n[0],t[1]=a[1]+n[1],t},subtract:qa,multiply:wa,divide:ya,ceil:function(t,a){return t[0]=Math.ceil(a[0]),t[1]=Math.ceil(a[1]),t},floor:function(t,a){return t[0]=Math.floor(a[0]),t[1]=Math.floor(a[1]),t},min:function(t,a,n){return t[0]=Math.min(a[0],n[0]),t[1]=Math.min(a[1],n[1]),t},max:function(t,a,n){return t[0]=Math.max(a[0],n[0]),t[1]=Math.max(a[1],n[1]),t},round:function(t,a){return t[0]=Math.round(a[0]),t[1]=Math.round(a[1]),t},scale:function(t,a,n){return t[0]=a[0]*n,t[1]=a[1]*n,t},scaleAndAdd:function(t,a,n,r){return t[0]=a[0]+n[0]*r,t[1]=a[1]+n[1]*r,t},distance:ga,squaredDistance:Aa,length:Ra,squaredLength:Pa,negate:function(t,a){return t[0]=-a[0],t[1]=-a[1],t},inverse:function(t,a){return t[0]=1/a[0],t[1]=1/a[1],t},normalize:function(t,a){var n=a[0],r=a[1],u=n*n+r*r;return u>0&&(u=1/Math.sqrt(u)),t[0]=a[0]*u,t[1]=a[1]*u,t},dot:function(t,a){return t[0]*a[0]+t[1]*a[1]},cross:function(t,a,n){var r=a[0]*n[1]-a[1]*n[0];return t[0]=t[1]=0,t[2]=r,t},lerp:function(t,a,n,r){var u=a[0],e=a[1];return t[0]=u+r*(n[0]-u),t[1]=e+r*(n[1]-e),t},random:function(t,a){a=a||1;var n=2*r()*Math.PI;return t[0]=Math.cos(n)*a,t[1]=Math.sin(n)*a,t},transformMat2:function(t,a,n){var r=a[0],u=a[1];return t[0]=n[0]*r+n[2]*u,t[1]=n[1]*r+n[3]*u,t},transformMat2d:function(t,a,n){var r=a[0],u=a[1];return t[0]=n[0]*r+n[2]*u+n[4],t[1]=n[1]*r+n[3]*u+n[5],t},transformMat3:function(t,a,n){var r=a[0],u=a[1];return t[0]=n[0]*r+n[3]*u+n[6],t[1]=n[1]*r+n[4]*u+n[7],t},transformMat4:function(t,a,n){var r=a[0],u=a[1];return t[0]=n[0]*r+n[4]*u+n[12],t[1]=n[1]*r+n[5]*u+n[13],t},rotate:function(t,a,n,r){var u=a[0]-n[0],e=a[1]-n[1],o=Math.sin(r),i=Math.cos(r);return t[0]=u*i-e*o+n[0],t[1]=u*o+e*i+n[1],t},angle:function(t,a){var n=t[0],r=t[1],u=a[0],e=a[1],o=n*n+r*r;o>0&&(o=1/Math.sqrt(o));var i=u*u+e*e;i>0&&(i=1/Math.sqrt(i));var h=(n*u+r*e)*o*i;return h>1?0:h<-1?Math.PI:Math.acos(h)},str:function(t){return"vec2("+t[0]+", "+t[1]+")"},exactEquals:function(t,a){return t[0]===a[0]&&t[1]===a[1]},equals:function(t,n){var r=t[0],u=t[1],e=n[0],o=n[1];return Math.abs(r-e)<=a*Math.max(1,Math.abs(r),Math.abs(e))&&Math.abs(u-o)<=a*Math.max(1,Math.abs(u),Math.abs(o))},len:ja,sub:za,mul:Ia,div:Sa,dist:Ea,sqrDist:Oa,sqrLen:Ta,forEach:Da});t.glMatrix=e,t.mat2=c,t.mat2d=b,t.mat3=w,t.mat4=S,t.quat=oa,t.quat2=pa,t.vec2=Fa,t.vec3=K,t.vec4=Pt,Object.defineProperty(t,"__esModule",{value:!0})});
